#pragma once

#include "Atlbase.h"

#import <msxml4.dll>
using namespace MSXML2;

#include <vector>
#include <string>
using namespace std;

//
#define __STARTNAMESPACE_NGBUILDMAKER		namespace NGBuildMaker {
#define __ENDNAMESPACE_NGBUILDMAKER			}
#define __USINGNAMESPACE_NGBUILDMAKER		using namespace NGBuildMaker;

// string > BSTR Convert
#define stringToBSTR(a) (char*)(_bstr_t(a.c_str()))

// CNGXmlWrap2
__STARTNAMESPACE_NGBUILDMAKER
class AFX_EXT_CLASS CNGXmlWrap2 : public CWnd
{
	DECLARE_DYNAMIC(CNGXmlWrap2)

public:
	CNGXmlWrap2();
	virtual ~CNGXmlWrap2();

	// Load
	bool Load(string _xmlpath);
	// Save
	bool Save(string _xmlpath);

	// SelectedNode
	bool SelectedNode(_bstr_t queryString);
	string SelectedNodeValue(int idx);

	// Extend
//	MSXML2::IXMLDOMNodePtr SelectedChildNode(_bstr_t queryString, int idx);
//	MSXML2::IXMLDOMNodeListPtr SelectedChildNodeList(MSXML2::IXMLDOMNodePtr nodeptr);

	// SelectedNode Count
	int GetSelectedNodeCount();

	// GetPath
	string GetPath() const;

	// Document ptr
	MSXML2::IXMLDOMDocument2Ptr GetDoc() { return m_pDoc; }

protected:
	MSXML2::IXMLDOMDocument2Ptr		m_pDoc;
	string							m_xmlPath;
	MSXML2::IXMLDOMNodeListPtr		m_pSelectedNodeList;
protected:
	DECLARE_MESSAGE_MAP()
};

typedef CNGXmlWrap2*				lpCNGXmlWrap2;
typedef CNGXmlWrap2&				refCNGXmlWrap2;
typedef vector<CNGXmlWrap2>			vCNGXmlWrap2;
typedef vCNGXmlWrap2::iterator		iterCNGXmlWrap2;

__ENDNAMESPACE_NGBUILDMAKER

